org.modeshape.jcr.api.query

## Interface QueryResult

- All Superinterfaces:
    QueryResult

      public interface QueryResult
      extends QueryResult

  Replicates some of the methods introduced in JCR 2.0, but also provides an extension that allows accessing the JCR `PropertyType` for each of the columns.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `String[]` | `getColumnTypes()` Returns an array of the `PropertyType` name for each of the columns in this result.
    `String` | `getPlan()` Get a description of ModeShape's plan for executing this query.
    `Collection<String>` | `getWarnings()` Get any warnings that might describe potential problems with this query.

    - ### Methods inherited from interface javax.jcr.query.QueryResult

      `getColumnNames, getNodes, getRows, getSelectorNames`

- - ### Method Detail

    - #### getColumnTypes

          String[] getColumnTypes()

      Returns an array of the `PropertyType` name for each of the columns in this result.
      Returns:
        the array of property type names; never null, never has null elements, and the size always matches `QueryResult.getColumnNames()`.

    - #### getPlan

          String getPlan()

      Get a description of ModeShape's plan for executing this query. The plan uses relational algebra and operations, and may be used to get insight into what operations are performed when executing the query.

      Note that as of ModeShape 3.1, the plan is always captured and available, though this may change in future versions. This means that clients should be written to never expect a non-null String response from this method.

      Returns:
        the string representation of the query plan as executed by the query; may be null if the query plan was not captured for the query (though currently it is always captured)

    - #### getWarnings

          Collection<String> getWarnings()

      Get any warnings that might describe potential problems with this query.

      Note that a query that has warnings is not necessarily incorrect or potentially wrong - because of residual properties, ModeShape may produce warnings for queries that are perfectly valid.

      However, if a query does not give the expected results (during development), check the warnings to see if ModeShape can suggest specific things to look at. For example, a warnings might suggest that a column might be resolved on a different selector, or that a column might have been misspelled.

      Returns:
        the collection of warnings; never null be empty when there are no warnings

Copyright © 2008-2014 JBoss, a division of Red Hat. All Rights Reserved.